## ros-kinetic-footstep-planner 0.4.2

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 2.8.3)
project(footstep_planner)

################################################################################
# Find catkin packages and libraries for catkin and system dependencies
################################################################################
find_package(catkin REQUIRED COMPONENTS 
  roscpp
  rospy
  actionlib
  rosconsole
  sensor_msgs
  geometry_msgs
  nav_msgs
  visualization_msgs
  humanoid_nav_msgs
  tf
  angles
  gridmap_2d
  map_server
)

find_package(OpenCV REQUIRED)

find_package(PkgConfig REQUIRED)
pkg_check_modules(SBPL REQUIRED sbpl)
include_directories(${SBPL_INCLUDE_DIRS})
link_directories(${SBPL_LIBRARY_DIRS})

################################################################################
# Setup for python modules and scripts
################################################################################

################################################################################
# Declare ROS messages, services and actions
################################################################################

################################################################################
# Declare ROS dynamic reconfigure parameters
################################################################################

################################################################################
# Declare catkin specific configuration to be passed to dependent projects
################################################################################
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS
    roscpp
    rospy
    actionlib
    rosconsole
    sensor_msgs
    geometry_msgs
    nav_msgs
    visualization_msgs
    humanoid_nav_msgs
    tf
    angles
    gridmap_2d
    map_server
  DEPENDS OpenCV SBPL
)

################################################################################
# Build
################################################################################
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
  ${SBPL_INCLUDE_DIRS}
)

set(FOOTSTEP_PLANNER_FILES 
  src/FootstepPlanner.cpp
	src/FootstepNavigation.cpp
  src/FootstepPlannerNode.cpp
  src/FootstepPlannerEnvironment.cpp 
  src/Footstep.cpp
  src/PlanningState.cpp
  src/Heuristic.cpp 
  src/helper.cpp
  src/PathCostHeuristic.cpp
  src/PlanningStateChangeQuery.cpp
  src/State.cpp
)

add_library(${PROJECT_NAME} ${FOOTSTEP_PLANNER_FILES})
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} ${SBPL_LIBRARIES})

add_executable(footstep_planner_node src/footstep_planner.cpp)
target_link_libraries(footstep_planner_node ${PROJECT_NAME} ${SBPL_LIBRARIES})

add_executable(footstep_planner_walls src/footstep_planner_walls.cpp)
target_link_libraries(footstep_planner_walls ${PROJECT_NAME} ${OpenCV_LIBRARIES} ${SBPL_LIBRARIES})

add_executable(footstep_navigation_node src/footstep_navigation.cpp)
target_link_libraries(footstep_navigation_node ${PROJECT_NAME} ${SBPL_LIBRARIES})

################################################################################
# Install
################################################################################
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS footstep_planner_node footstep_planner_walls footstep_navigation_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(PROGRAMS
  scripts/corrected_initialpose.py
  scripts/plan_footsteps.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY config launch maps 
	DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

################################################################################
# Test
################################################################################

=== debian/changelog ===
ros-kinetic-footstep-planner (0.4.2-0xenial) xenial; urgency=high

  * refacotoring to release on kinetic
  * added documents related to footstep_planner packages
  * added information new maintainer
  * fixed CMakeLists.txt and package.xml files for dependency
  * fixed footstep_planner node crashes when map changesth
  * Contributors: Aleksey Titov, Kayman, Pyo

 -- Pramuditha Aravinda <aravindadp@gmail.com>  Wed, 18 Apr 2018 15:00:00 -0000

ros-kinetic-footstep-planner (0.4.1-0xenial) xenial; urgency=high

  * Added include files for footstep_planner and gridmap_2d for install.
  * uses double 2.0 and makes style locally consistent
  * catkinize the stack
  * Add service to (re)plan between feet as start and goal.
  * Requires newest humanoid_msgs.
  * Merge plan and replan functions
  * RViz launch file / config Groovy
  * mark heuristic as expired when map is updated
  * removed code in the destructor that gets already cleaned up in the super class
  * use pre-increment instead of post-increment (faster + post-increment for iterators not always optimizable)
  * fixed sbpl exception catch
  * introduced new functionality to totally reset the planning environment
  * storing environment params in new struct -- get rid of unnecessary member variables
  * more detailed information when sbpl planning was successful but only the old path is returned
  * wait 0.5 sec before updating the start (robot) pose
  * bug fix in path cost heuristic
  * make footsteps smaller; +  std::max
  * handle receiving of foot transformations differently
  * implemented the polygon-intersection-check for the navigation as well; not used so far due to some usability issues
  * bug resolved: free the execution log when planning failed; use ros::Time(0) instead of ros::Time::now() since when using the latter sometimes the tf cannot be received (now sometimes an outdated step is received but this works better anyhow)
  * bug resulting in segfaulting thread now (probably) resolved
  * replaced old reachable check by a new more smoother grid based approach
  * small fix in the replanning logic
  * enforce planning from scratch when necessary (e.g. goal changed when using backward planning)
  * added assertion to enforce correct heuristic calculation
  * applied ROS code style
  * reorganized the way FootstepNavigation invokes the planner and starts the execution; changed FootstepPlanner::updateMap
  * Contributors: Armin Hornung, Johannes Garimort, Pramuditha Aravinda, Vincent Rabaud, enriquefernandez

 -- Pramuditha Aravinda <aravindadp@gmail.com>  Sun, 04 Sep 2016 15:00:00 -0000

ros-kinetic-footstep-planner (0.4.0-0xenial) xenial; urgency=high

  * Updated stack.xml & CMakeLists, new version 0.4.0 to release
  * adjusted robot translation in z dir
  * footstep execution now aborted when map changes + replanning and new execution is started; again use ALL calculated steps when extracting the path
  * Changes in R* launch file params
  * using only the new launch file from pkg nao_driver
  * Fixed odometry lookup error (wrong frame)
  * Indenting / code style according to ROS style
  * fixed SBPL in CMakeListe for custom-installed location
  * fixed out of map check in R*
  * cleanup of R* code
  * manifest/CMakeLists now compatible with fuerte and electric compilation, includes should work better now
  * integrated the new footstep set
  * fix: spelling error (don't forget to update nao_driver and humanoid_nav_msgs)
  * navigation parameters in extra config file; using new launch file in nao_driver
  * handle situations where both start feet are part of the calculated solution
  * method rearrangement in the navigation
  * got rid of get_footstep in helper
  * added test to check whether all footsteps can be performed by the NAO robot; adjusted invalid footstep
  * now able to switch between protective and fast footstep execution via the 'protective_execution' param + various smaller changes
  * Finished fluid footstep execution for the NAO; has still to be tested for simulation/real robot
  * added footstep_planner_walls to read in separate wall map (larger clearing)
  * expanded states is now a hash map on x,y => vis.better in RVIZ, only one expanded state per (x,y)
  * heuristic_scale parameter to increase under-estimating heuristics
  * GetSuccsTo for improved R* functionality
  * nao_path_follower now accepts paths
  * Fixed PathCostHeuristic for non-square maps
  * reaching right goal foot faster, only left goal state absorbs now.
  * also show expanded states when failing; R* optimized (exact ==)
  * PathCostHeuristic is now inflated by foot incircle
  * Contributors: Armin Hornung, Daniel Maier, Johannes Garimort

 -- Pramuditha Aravinda <aravindadp@gmail.com>  Wed, 09 Jan 2013 15:00:00 -0000

ros-kinetic-footstep-planner (0.3.1-0xenial) xenial; urgency=high

  * preparing for fuerte release and sbpl package
  * replanning based on old planning info in cases of a changed map disabled for now (instead: complete new planning in such a case)
  * approx. comparison for R*
  * footstep-feedback synchronization now handled in the action client (in FootstepNavigation.cpp)
  * cost calculation directly based on the discrete planning states
  * during the planning the reachability check is now based on the discrete position and orientation of the state (planning speed up)
  * temp. simplification of the path cost heuristic calculation
  * temp simplification of heuristic calculation
  * code cleanup
  * updated RViz config, launch file for R*
  * slightly expanded large footstep set
  * Contributors: Armin Hornung, Johannes Garimort

 -- Pramuditha Aravinda <aravindadp@gmail.com>  Thu, 14 Jun 2012 15:00:00 -0000

ros-kinetic-footstep-planner (0.3.0-0xenial) xenial; urgency=high

  * changed default planning params: 1cm res, PathCostHeuristic
  * synchronized with footstep action server
  * PathCostHeuristic fixed
  * added fake localization launch file
  * documentation update


=== debian/control ===
Source: ros-kinetic-footstep-planner
Section: misc
Priority: extra
Maintainer: Pramuditha Aravinda <aravindadp@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, ros-kinetic-actionlib, ros-kinetic-angles, ros-kinetic-catkin, ros-kinetic-geometry-msgs, ros-kinetic-gridmap-2d, ros-kinetic-humanoid-nav-msgs, ros-kinetic-map-server, ros-kinetic-nav-msgs, ros-kinetic-rosconsole, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sbpl, ros-kinetic-sensor-msgs, ros-kinetic-tf, ros-kinetic-visualization-msgs
Homepage: http://wiki.ros.org/footstep_planner
Standards-Version: 3.9.2

Package: ros-kinetic-footstep-planner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, ros-kinetic-actionlib, ros-kinetic-angles, ros-kinetic-geometry-msgs, ros-kinetic-gridmap-2d, ros-kinetic-humanoid-nav-msgs, ros-kinetic-map-server, ros-kinetic-nav-msgs, ros-kinetic-rosconsole, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sbpl, ros-kinetic-sensor-msgs, ros-kinetic-tf, ros-kinetic-visualization-msgs
Description: A footstep planner for humanoid / biped robots.
 The planner builds on SBPL and has anytime as well as dynamic replanning capabilities. The supported planners are: ARA*, AD*, R*. Details can be found in the following publications: &quot;Humanoid Navigation with Dynamic Footstep Plans&quot; by J. Garimort, A. Hornung, and M. Bennewitz; published in Proc. of the IEEE International Conference on Robotics &amp; Automation (ICRA), 2011 Anytime Search-Based Footstep Planning with Suboptimality Bounds by A. Hornung, A. Dornbush, M. Likhachev, and M. Bennewitz; published in Proc. of the IEEE-RAS International Conference on Humanoid Robots (HUMANOIDS), 2012

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-footstep-planner//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
